searchNodes=[{"doc":"GenServer for persistent opts","ref":"LogfmtEx.html","title":"LogfmtEx","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"LogfmtEx.html#child_spec/1","title":"LogfmtEx.child_spec/1","type":"function"},{"doc":"","ref":"LogfmtEx.html#format/4","title":"LogfmtEx.format/4","type":"function"},{"doc":"","ref":"LogfmtEx.html#start_link/1","title":"LogfmtEx.start_link/1","type":"function"},{"doc":"Encodes key/value pairs.","ref":"LogfmtEx.Encoder.html","title":"LogfmtEx.Encoder","type":"module"},{"doc":"","ref":"LogfmtEx.Encoder.html#encode/3","title":"LogfmtEx.Encoder.encode/3","type":"function"},{"doc":"","ref":"LogfmtEx.Encoder.html#t:key/0","title":"LogfmtEx.Encoder.key/0","type":"type"},{"doc":"Formats logs in logfmt format. This module allows developers to specify a list of atoms that serves as template for log messages, for example: [:timestamp, :level, :message, :metadata] Will print an error message as: timestamp = &quot;18:43:12 2022-5-22&quot; level = error message = &quot;oh no spaghettio&quot; user_id = 13 The valid parameters you can use are: :timestamp - the time and date the log message was sent :message - the log message :level - the log level :node - the node that printed the message :metadata - the metadata attached to the log","ref":"LogfmtEx.Formatter.html","title":"LogfmtEx.Formatter","type":"module"},{"doc":"","ref":"LogfmtEx.Formatter.html#format/5","title":"LogfmtEx.Formatter.format/5","type":"function"},{"doc":"","ref":"LogfmtEx.Formatter.html#t:pattern/0","title":"LogfmtEx.Formatter.pattern/0","type":"type"},{"doc":"","ref":"LogfmtEx.Formatter.html#t:pattern_keys/0","title":"LogfmtEx.Formatter.pattern_keys/0","type":"type"},{"doc":"","ref":"LogfmtEx.ValueEncoder.html","title":"LogfmtEx.ValueEncoder","type":"protocol"},{"doc":"","ref":"LogfmtEx.ValueEncoder.html#encode/1","title":"LogfmtEx.ValueEncoder.encode/1","type":"function"},{"doc":"","ref":"LogfmtEx.ValueEncoder.html#t:t/0","title":"LogfmtEx.ValueEncoder.t/0","type":"type"},{"doc":"LogfmtEx A log formatter for the logfmt format popularized by Heroku. Logger . info ( &quot;I am a message&quot; , user_id : 123 ) level = info msg = &quot;I am a message&quot; ts = &quot;12:38:38.055 1973-03-12&quot; user_id = 123 pid = # PID &lt; 0 . 223 . 0 &gt; file = test / logfmt_ex_test . exs","ref":"readme.html","title":"README","type":"extras"},{"doc":"The package can be installed by adding logfmt_ex to your list of dependencies in mix.exs : def deps do [ { :logfmt_ex , &quot;~&gt; 0.3&quot; } ] end In your app's logger configuration, specify the LogfmtEx module and its format function to be used to format your logs: config :logger , :console , format : { LogfmtEx , :format } And add logfmt_ex to your extra_applications in mix.exs : def application do [ mod : { YourApp.Application , [ ] } , extra_applications : [ :logfmt_ex , :logger ] ] end You can customize the formatting in your config: config :logfmt_ex , :opts , message_key : &quot;msg&quot; , timestamp_key : &quot;ts&quot; , timestamp_format : :iso8601","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":":delimiter - defaults to = . :format - A list of atoms that defines the order in which key/value pairs will written to the log line. Defaults to [:timestamp, :level, :message, :metadata] . Valid parameters are :timestamp - the timestamp of the log message :level - the log level :message - the log message itself :metadata - metadata as key=value paris :node - the node name timestamp_key - changes the key used for the timestamp field. Defaults to timestamp . timestamp_format - How the timestamp is formatted. Defaults to :elixir . The options are :elixir - Uses the same formatting functions found in the standard elixir log formatter. Example: &quot;12:38:38.055 1973-03-12&quot; :epoch_seconds - outputs an integer representing the number of seconds elapsed since January 1, 1970. Only useful for applications that emit logs sporadically. :iso8601 - Formats the timestamp according to ISO8601-2019. Example: 2000-02-29T23:00:07 level_key - the key used for the log level. Defaults to level . message_key - the key used for the message field. Defaults to message , but msg is a popular alternative.","ref":"readme.html#configuration","title":"README - Configuration","type":"extras"},{"doc":"Structs can be encoded via the LogfmtEx.ValueEncoder protocol. defmodule User do defstruct [ :email , :name , :id ] defimpl LogfmtEx.ValueEncoder do @doc &quot;&quot;&quot; As we don&#39;t want to leak PII into our logs, we encode the struct to just the user&#39;s ID. &quot;&quot;&quot; def encode ( user ) , do : to_string ( user . id ) end Types for which the protocol is not implemented will fall back to the to_string/1 function in the String.Chars protocol. If the term being encoded does not implement that protocol, the formatter will fall back to the Inspect protocol. Note that the algebra documents produced by Kernel.inspect/1 don't lend themselves to logfmt - this fallback is provided to minimize the chance that the formatter fails, instead making a &quot;best effort&quot; at producing usable output. It is recommended to implement either the LogfmtEx.ValueEncoder or String.Chars protocol for any data structures that might find their way into your logs.","ref":"readme.html#encoding","title":"README - Encoding","type":"extras"},{"doc":"This library uses asdf to manage runtime versions of Elixir and Erlang.","ref":"readme.html#testing-and-development","title":"README - Testing and Development","type":"extras"},{"doc":"LogfmtEx is a simple logfmt formatter specifically for the Elixir console backend. If you're looking for a library to encode and decode logfmt, take a look at logfmt-elixir instead.","ref":"readme.html#alternatives","title":"README - Alternatives","type":"extras"}]